<?php

global $smarty, $oPlugin;

require_once(PFAD_ROOT . PFAD_INCLUDES . "tools.Global.php");
require_once(PFAD_ROOT . PFAD_CLASSES . "class.JTL-Shop.Bestellung.php");
require_once(PFAD_ROOT . PFAD_ADMIN . PFAD_INCLUDES . "blaetternavi.php");
require_once(PFAD_ROOT . PFAD_ADMIN . PFAD_INCLUDES . "bestellungen_inc.php");
require_once(PFAD_ROOT . PFAD_INCLUDES_MODULES . 'PaymentMethod.class.php');

$success = '';
$error = '';
$cSuchFilter = '';
$cSuche = '';
$tabOrders = false;

// navigation
$nAnzahlProSeite = 15;
$oBlaetterNaviConf = baueBlaetterNaviGetterSetter(1, $nAnzahlProSeite);
if (isset($_POST['submit-action'])) {
    $cOrderId = isset($_POST['orderId']) ? filterXSS($_POST['orderId']) : '';
    $method = isset($_POST['paymentMethod']) ? filterXSS($_POST['paymentMethod']) : '';
    $action = isset($_POST['submit-action']) ? filterXSS($_POST['submit-action']) : '';

    $name = str_replace('skrill_', '', $method);

    $paymentMethod = PaymentMethod::create('kPlugin_'.$oPlugin->kPlugin.'_'.$name);

    if ($action == 'update') {
        $result = $paymentMethod->doUpdateStatus($cOrderId);

        if ($result === 'GENERAL_ERROR') {
            $_SESSION['skrill_order_backend_action']['error'] = 'ERROR_UPDATE_BACKEND';
        }
    } elseif ($action == 'refund') {
        $result = $paymentMethod->doBackendRefund($cOrderId);

        if ($result === 'GENERAL_ERROR') {
            $_SESSION['skrill_order_backend_action']['error'] = 'ERROR_GENERAL_REFUND_PAYMENT';
        }
    }

    
    if ($result === 'CANNOT_LOGIN') {
        $_SESSION['skrill_order_backend_action']['error'] = 'ERROR_UPDATE_MQI_BACKEND';
    } elseif ($result === 'ACCOUNT_LOCKED') {
        $_SESSION['skrill_order_backend_action']['error'] = 'ERROR_UPDATE_LOCKED_BACKEND';
    } elseif ($result === $paymentMethod::PROCESSED_STATUS || $result === $paymentMethod::PENDING_STATUS) {
        if ($action == 'refund' && $result == $paymentMethod::PENDING_STATUS) {
            $_SESSION['skrill_order_backend_action']['success'] = 'SUCCESS_GENERAL_REFUND_PAYMENT_PENDING';
        } else {
            $_SESSION['skrill_order_backend_action']['success'] = 'SUCCESS_GENERAL_'.strtoupper($action).'_PAYMENT';
        }
    } elseif ($result === $paymentMethod::NOT_VERIFIED_STATUS) {
        $_SESSION['skrill_order_backend_action']['error'] = 'ERROR_UPDATE_NOTVERIFIED_BACKEND';
    } else {
        $_SESSION['skrill_order_backend_action']['error'] = $result;
    }

    if (isset($_SESSION['skrill_order_backend_action'])) {
        $header = 'Location: ' . Shop::getURL() . '/' . PFAD_ADMIN . 'plugin.php?kPlugin=' . $oPlugin->kPlugin;
        header($header);
        exit();
    }
}

if (isset($_SESSION['skrill_order_backend_action']['error'])) {
    $error = $oPlugin->oPluginSprachvariableAssoc_arr[$_SESSION['skrill_order_backend_action']['error']];
    unset($_SESSION['skrill_order_backend_action']);
} elseif (isset($_SESSION['skrill_order_backend_action']['success'])) {
    $success = $oPlugin->oPluginSprachvariableAssoc_arr[$_SESSION['skrill_order_backend_action']['success']];
    unset($_SESSION['skrill_order_backend_action']);
}

// orders
$nAnzahlBestellungen = Shop::DB()->query("SELECT tbestellung.kBestellung from tbestellung
	INNER JOIN xplugin_jtl_skrill_orders
	ON tbestellung.kBestellung = xplugin_jtl_skrill_orders.order_id", 3);

if (isset($_POST['submitSuche']) && isset($_POST['cSuche']) && $_POST['cSuche'] != '') {
    $cSuche = isset($_POST['cSuche']) ? $_POST['cSuche'] : '';
    $tabOrders = true;
    $oBestellung_arr = Shop::DB()->query("SELECT tbestellung.kBestellung,
        xplugin_jtl_skrill_orders.currency,
        xplugin_jtl_skrill_orders.payment_method,
        xplugin_jtl_skrill_orders.payment_type,
        xplugin_jtl_skrill_orders.transaction_id,
        xplugin_jtl_skrill_orders.pay_from_email,
        xplugin_jtl_skrill_orders.order_originated_from,
        xplugin_jtl_skrill_orders.card_issuer_country,
        xplugin_jtl_skrill_orders.status from tbestellung
        INNER JOIN xplugin_jtl_skrill_orders
        ON tbestellung.kBestellung = xplugin_jtl_skrill_orders.order_id
        WHERE tbestellung.cBestellNr = {$cSuche}", 2);
} else {
    $tabOrders = true;

    $oBestellung_arr = Shop::DB()->query("SELECT tbestellung.kBestellung,
        xplugin_jtl_skrill_orders.currency,
        xplugin_jtl_skrill_orders.payment_method,
    	xplugin_jtl_skrill_orders.payment_type,
    	xplugin_jtl_skrill_orders.mb_transaction_id,
        xplugin_jtl_skrill_orders.pay_from_email,
    	xplugin_jtl_skrill_orders.order_originated_from,
    	xplugin_jtl_skrill_orders.card_issuer_country,
    	xplugin_jtl_skrill_orders.status from tbestellung
    	INNER JOIN xplugin_jtl_skrill_orders
    	ON tbestellung.kBestellung = xplugin_jtl_skrill_orders.order_id
    	ORDER BY kBestellung DESC {$oBlaetterNaviConf->cSQL1}", 2);
}

// fill
foreach ($oBestellung_arr as &$oBestellung) {
    $currency = $oBestellung->currency;
    $paymentMethod = $oBestellung->payment_method;
    $paymentType = $oBestellung->payment_type;
    $mbTransactionId = $oBestellung->mb_transaction_id;
    $orderOriginatedFrom = $oBestellung->order_originated_from;
    $cardIssuerCountry = $oBestellung->card_issuer_country;
    $status = $oBestellung->status;
    $pay_from_email = $paymentMethod == 'skrill_skrillwallet' ? $oBestellung->pay_from_email : '';

    $oBestellung = new Bestellung($oBestellung->kBestellung);
    $oBestellung->cCurrency = $currency;
    $oBestellung->cPaymentMethod = $paymentMethod;
    $oBestellung->cPaymentType = $paymentType;
    $oBestellung->cMbTransactionId = $mbTransactionId;
    $oBestellung->cOrderOriginatedFrom = $orderOriginatedFrom;
    $oBestellung->cCardIssuerCountry = $cardIssuerCountry;
    $oBestellung->cStatus = $status;
    $oBestellung->pay_from_email = $pay_from_email;
    $oBestellung->fuelleBestellung(1, 0);
}

// navigation
$oBlaetterNaviUebersicht = baueBlaetterNavi(
    $oBlaetterNaviConf->nAktuelleSeite1,
    $nAnzahlBestellungen,
    $nAnzahlProSeite
);

// template
$smarty->assign('cHinweis', $success)
       ->assign('cFehler', $error)
       ->assign('cSuche', $cSuche)
       ->assign('tabOrders', $tabOrders)
       ->assign('oBestellung_arr', $oBestellung_arr)
       ->assign("oBlaetterNaviUebersicht", $oBlaetterNaviUebersicht)
       ->assign('adminURL', Shop::getURL() . '/' . PFAD_ADMIN . 'plugin.php')
       ->assign('adminURLParam', 'kPlugin=' . $oPlugin->kPlugin)
       ->display($oPlugin->cAdminmenuPfad . "template/order.tpl");
